#include "stm32f10x.h"

#define uint unsigned int
#define uchar unsigned char

#define CLOCK 72/8 //ʱ=72M

/*------------------------------------------------------------
                         usʱ 
------------------------------------------------------------*/
void delay_us(unsigned int us)
{
	u8 n;		    
	while(us--)for(n=0;n<CLOCK;n++); 	 
}

/*------------------------------------------------------------
                         msʱ
------------------------------------------------------------*/
void delay_ms(unsigned int ms)
{
	while(ms--)delay_us(1000);	 
}

/*------------------------------------------------------------
                      ʱӼĴλ
------------------------------------------------------------*/
void RCC_DeInit(void)
{									   
	RCC->APB2RSTR = 0x00000000;//踴λ			 
	RCC->APB1RSTR = 0x00000000;   	  
  	RCC->AHBENR = 0x00000014;  //flashʱ,ʱʹ.DMAʱӹر	  
  	RCC->APB2ENR = 0x00000000; //ʱӹر.			   
  	RCC->APB1ENR = 0x00000000;   
	RCC->CR |= 0x00000001;     //ʹڲʱHSION	 															 
	RCC->CFGR &= 0xF8FF0000;   //λSW[1:0],HPRE[3:0],PPRE1[2:0],PPRE2[2:0],ADCPRE[1:0],MCO[2:0]					 
	RCC->CR &= 0xFEF6FFFF;     //λHSEON,CSSON,PLLON
	RCC->CR &= 0xFFFBFFFF;     //λHSEBYP	   	  
	RCC->CFGR &= 0xFF80FFFF;   //λPLLSRC, PLLXTPRE, PLLMUL[3:0] and USBPRE 
	RCC->CIR = 0x00000000;     //رж
}


/*------------------------------------------------------------
                  ⲿ8M,õ72Mϵͳʱ
------------------------------------------------------------*/	
void Stm32_Clock_Init(void)
{
	unsigned char temp=0;
	u8 timeout=0;
	RCC_DeInit();
	RCC->CR|=0x00010000;  //ⲿʱʹHSEON

	timeout=0;
	while(!(RCC->CR>>17)&&timeout<200)timeout++;//ȴⲿʱӾ	 

	//0-24M ȴ0;24-48M ȴ1;48-72Mȴ2;(ǳҪ!)	   
	FLASH->ACR|=0x32;//FLASH 2ʱ

	RCC->CFGR|=0X001D2400;//APB1/2=DIV2;AHB=DIV1;PLL=9*CLK;HSEΪPLLʱԴ
	RCC->CR|=0x01000000;  //PLLON

	timeout=0;
	while(!(RCC->CR>>25)&&timeout<200)timeout++;//ȴPLL

	RCC->CFGR|=0x00000002;//PLLΪϵͳʱ
	while(temp!=0x02&&timeout<200)     //ȴPLLΪϵͳʱóɹ
	{   
		temp=RCC->CFGR>>2;
		timeout++;
		temp&=0x03;
	}  
}

